require 'uu/os/rest/dto'
require 'uu/os/uesuri'



module UU
  module ADK
    module App
      # App Entry Attributes DTO.
      # @deprecated Use {UU::OS::AppMetaModel::AppMetaModelEntryAttributes} instead.
      class AppEntryAttributes < UU::OS::REST::DTO

        # Normalized UESURI of the entry (artifact or shortcut). Never nil.
        attr_accessor :uri

        # Name of the entry (artifact or shortcut). Never nil.
        attr_accessor :name

        # Code of the entry (artifact or shortcut). Never nil.
        attr_accessor :code

        # Description of the entry (artifact or shortcut). Never nil.
        attr_accessor :description
        
        # UESURI of the entity type of the artifact (see @{cz.ues.platform.sysc.entitytype.UESEntityType} for more info). It is the other
        # artifact, the one different from the main entity. More precisely it is the referenced artifact in case of outgoing reference, the
        # referencing artifact in case of incoming reference. Never nil.
        attr_accessor :entity_type_uri

        def uri
          attributes[:uri]
        end

        def uri=(val)
          if val
            attributes[:uri] = UU::OS::UESURI.new(val)
          else
            attributes[:uri] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

     
        def entity_type_uri
          attributes[:entityTypeUri]
        end

        def entity_type_uri=(val)
          if val
            attributes[:entityTypeUri] = UU::OS::UESURI.new(val)
          else
            attributes[:entityTypeUri] = nil
          end
        end

      end
    end

  end
end
